# Libraries

Hydrosphere exposes libraries that can be used to interact with services. We use these libraries internally, but you can also use them to implement integrations.

## Python

Protobuf compiled messages and services: <https://pypi.org/project/hydro-serving-grpc/\\>
Software Development Kit: <https://pypi.org/project/hydrosdk/\\>
Command Line Interface: <https://pypi.org/project/hs/>

## Scala

Protobuf compiled messages and services: <https://search.maven.org/search?q=a:serving-grpc-scala\\_2.13>

## Java

Protobuf compiled messages and services: <https://search.maven.org/search?q=a:serving-grpc-java-11>

## Protobuf

API and entities: <https://github.com/Hydrospheredata/hydro-serving-protos>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hydrosphere.io/master/resources/reference/libraries.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
